unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, _Osoba, ComCtrls, ExtCtrls, DB, DBClient, Grids,
  DBGrids;

type
  TForm1 = class(TForm)
    edtOsobaIme: TEdit;
    btnBrak: TButton;
    btnDete: TButton;
    TreeView1: TTreeView;
    chkPol: TCheckBox;
    lstDeca: TListBox;
    lstBraca: TListBox;
    lstSestre: TListBox;
    edtOsobaPartner: TEdit;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    btnSacuvaj: TButton;
    btnUcitaj: TButton;
    cds: TClientDataSet;
    cdsID: TIntegerField;
    cdsIDRoditelj: TIntegerField;
    cdsIme: TStringField;
    cdsMusko: TBooleanField;
    cdsImePartnera: TStringField;
    procedure btnDeteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnBrakClick(Sender: TObject);
    procedure btnShowClick(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure btnSacuvajClick(Sender: TObject);
    procedure btnUcitajClick(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
  private
    { Private declarations }
    FKoren: TOsoba;
    FTemp: TOsoba;
    function GetAppPath: string;
    function GetDataFileName: string;
  public
    { Public declarations }
    procedure ShowStablo;
    procedure ShowDetailData;
  end;

var
  Form1: TForm1;

implementation

uses _dlgOsoba;

{$R *.dfm}

procedure TForm1.btnDeteClick(Sender: TObject);
var
  aDete: TOsoba;
begin
  with TdlgOsoba.Create(nil) do
  begin
    Caption := edtOsobaIme.Text + ' novo dete: ';

    if ShowModal = mrOk then
    begin
      aDete := TOsoba.Create;
      aDete.Ime := edtIme.Text;
      aDete.Musko := chkMusko.Checked;

      FTemp.NovoDete( aDete);

      ShowStablo;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FKoren := TOsoba.Create;
  FKoren.Ime := 'deda Miloje';
  FKoren.Musko := true;

  FTemp := FKoren;

  edtOsobaIme.Text := FKoren.Ime;
end;

procedure TForm1.btnBrakClick(Sender: TObject);
var
  aPartner: TOsoba;
begin
  with TdlgOsoba.Create(nil) do
  begin
    Caption := edtOsobaIme.Text + ' brak: ';
    chkMusko.Checked := not FTemp.Musko; // radi lakseg unosa.

    if ShowModal = mrOk then
    begin
      aPartner := TOsoba.Create;
      aPartner.Ime := edtIme.Text;
      aPartner.Musko := chkMusko.Checked;

      FTemp.BrakSa( aPartner);

      ShowStablo;
    end;
  end;
end;

procedure TForm1.btnShowClick(Sender: TObject);
begin
  showStablo;
end;

procedure TForm1.TreeView1Click(Sender: TObject);
begin
  //ShowDetailData;
end;

procedure TForm1.ShowDetailData;
var
  aRoditelj, aDete: TOsoba;
  i: integer;
begin
  if self.TreeView1.Selected = nil then exit;

  FTemp := TOsoba( TreeView1.Selected.Data);

  // popunjavamo podatke za izabranu osobu:
  edtOsobaIme.Text := FTemp.Ime;
  edtOsobaPartner.Text := FTemp.ImePartnera;
  chkPol.Checked := FTemp.Musko;

  // iscitava decu:
  lstDeca.Clear;
  if assigned( FTemp.Deca) then // mora provera!
  begin
    for i:=0 to FTemp.Deca.Count-1 do
    begin
      aDete := TOsoba(FTemp.Deca.Objects[i]);
      lstDeca.Items.Add( aDete.Ime);
    end;
  end;

  // za bracu i seste:
  lstBraca.Clear;  lstSestre.Clear; // brisemo liste...
  if assigned( FTemp.Roditelj) then // mora provera!
  begin
    aRoditelj := FTemp.Roditelj;
    for i:=0 to aRoditelj.Deca.Count-1 do
    begin
      aDete := TOsoba( aRoditelj.Deca.Objects[i]);
      if aDete.Ime <> FTemp.Ime then // osoba ne moze samoj sebi da bude brat/sestra!
      begin
        if aDete.Musko then
          lstBraca.Items.Add( aDete.Ime)
        else
          lstSestre.Items.Add( aDete.Ime);
      end;
    end;
  end;
end;

procedure TForm1.ShowStablo;

  function DodajOsobu( aParentNode: TTreeNode; aOsoba: TOsoba): TTreeNode;
  begin
    Result := TreeView1.Items.AddChildObject( aParentNode,
       aOsoba.Ime + ' : '+ aOsoba.ImePartnera, aOsoba);
  end;

  function DodajDecu( aRoot: TTreeNode; aOsoba: TOsoba): TTreeNode;
  var
    i: integer;
    aDete: TOsoba;
  begin
    Result := DodajOsobu( aRoot, aOsoba);

    // dodaje decu za datu aOsoba instancu:
    if assigned( aOsoba.Deca) then
      for i:=0 to aOsoba.Deca.Count-1 do
      begin
        aDete := TOsoba( aOsoba.Deca.Objects[i]);
        // opet poziv metode sa istim nazivom: DodajDecu?
        // ovo je tzv rekurzija:
        // za svako dete, dodaj njegovu decu...
        DodajDecu( Result, aDete);
      end;
  end;

begin
  with TreeView1 do
  begin
    Items.Clear;
    DodajDecu( nil, FKoren);
  end;
end;


procedure TForm1.btnSacuvajClick(Sender: TObject);

  procedure SacuvajOsobu( aOsoba: TOsoba);
  var
    iIDRod: integer;
  begin
    if assigned( aOsoba.Roditelj) then
        iIDRod := aOsoba.Roditelj.ID
      else
        iIDRod := -1;

    with cds do
    begin
      Insert;
      FieldByName('ID').AsInteger         := aOsoba.ID;
      FieldByName('IDRoditelj').AsInteger := iIDRod;
      FieldByName('Ime').AsString         := aOsoba.Ime;
      FieldByName('Musko').AsBoolean      := aOsoba.Musko;
      FieldByName('ImePartnera').AsString := aOsoba.ImePartnera;
      Post;
    end;
  end;

  procedure SnimiClanove( aOsoba: TOsoba);
  var
    i: integer;
    aDete: TOsoba;
  begin
    SacuvajOsobu( aOsoba);

    // dodaje decu za datu aOsoba instancu:
    if assigned( aOsoba.Deca) then
      for i:=0 to aOsoba.Deca.Count-1 do
      begin
        aDete := TOsoba( aOsoba.Deca.Objects[i]);
        SnimiClanove( aDete);
      end;
  end;

begin
  cds.EmptyDataSet; // pripremimo za clanove

  // krecemo se kroz celo stablo, i snimamo podatke
  // slicna fora kao i kod prikaza podataka (ShowStablo)
  SnimiClanove( FKoren);

  cds.SaveToFile( GetDataFileName);
end;

function TForm1.GetAppPath: string;
begin
   // vraca sa / na kraju
  Result := IncludeTrailingPathDelimiter(ExtractFilePath( Application.ExeName));
end;

function TForm1.GetDataFileName: string;
begin
  Result := self.GetAppPath  + 'stablo.xml';
end;

procedure TForm1.btnUcitajClick(Sender: TObject);

  procedure UcitajOsobu( aCDS: TClientDataSet; aOsoba: TOsoba);
  var
    sPartner: string;
    aPartner: TOsoba;
  begin
    with aCDS do
    begin
      aOsoba.ID          := FieldByName('ID').AsInteger    ;
      aOsoba.Ime         := FieldByName('Ime').AsString    ;
      aOsoba.Musko       := FieldByName('Musko').AsBoolean ;

      sPartner := FieldByName('ImePartnera').AsString;
      if CompareText( sPartner, '') <> 0 then
      begin
        // postoji partner za datu osobu:
        aPartner := TOsoba.Create;
        aPartner.Ime := sPartner;
        aPartner.Musko := not aOsoba.Musko;
        aOsoba.BrakSa( aPartner);
      end;
    end;
  end;

  procedure UcitajDecu( aCds: TClientDataset; aParent: TOsoba);
  var
    aDete: TOsoba;
    aClone: TClientDataSet;
  begin
    aClone := TClientDataSet.Create(nil);
    try
      aClone.CloneCursor( cds, true, true);
      with aClone do
      begin
        IndexFieldNames := 'IDRoditelj';
        SetRange([aParent.ID], [aParent.ID]);

        First;
        while not Eof do
        begin
          aDete := TOsoba.Create;
          UcitajOsobu( aClone, aDete);
          aParent.NovoDete( aDete);

          UcitajDecu( aClone, aDete);

          Next;
        end;
      end;
    finally
      aClone.Free;
    end;
  end;

begin
  cds.LoadFromFile( GetDataFileName);

  // trazimo koren stabla (idRoditelj = -1):
  cds.Locate('IDRoditelj', VarArrayOf(['-1']), []);

  UcitajOsobu( cds, FKoren);
  UcitajDecu( cds, FKoren);

  ShowStablo;
end;

procedure TForm1.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
  self.ShowDetailData;
end;

end.
